#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

const float M = 100;
const float c = 10;

float p(float q) { return M-q; }


void	zobch(float q1, float q2, float &s1, float &s2) 
{
	float qc=q1+q2;

	if (qc<=M) {
		s1=q1; s2=q2;
	} else {
		s1=q1*M/qc; s2=q2*M/qc;
	}
}


float	u(float s, float p)
{
	return s*p - s*c;
}


void	print_hra(int q1max, int q2max, int q1step, int q2step, FILE *nfg)
{
	float q1,q2;
	float s1,s2,sc,ph;

	int S1, S2;

	S1 = q1max/q1step + 1;
	S2 = q2max/q2step + 1;

	// Hlavicka pro gambit
	// NFG 1 R <komentar>
	fprintf(nfg, "NFG 1 R \"Experimenty Cournot\"\n");
	// jmena hracu, pocty strategii
	fprintf(nfg, "{ \"radkovy\" \"sloupcovy\" } { %d %d }\n", S1, S2);

	for (q2=0; q2<q2max; q2+=q2step) printf("%10.0f\t", q2); printf("\n");

	for (q1=0; q1<=q1max; q1+=q1step) {
		printf("%4.0f|\t", q1);
		for (q2=0; q2<=q2max; q2+=q2step) {
			zobch(q1,q2,s1,s2);
			sc = s1+s2;
			assert(sc<=M);
			ph = p(sc);
			printf("%4.0f,%4.0f|\t", u(s1,ph), u(s2,ph));
			fprintf(nfg, "%.0f %.0f ", u(s1,ph), u(s2,ph));
		}
		printf("\n");
	}


	// vypsat po sloupcich
	for (q2=0; q2<=q2max; q2+=q2step) {
	for (q1=0; q1<=q1max; q1+=q1step) {
			zobch(q1,q2,s1,s2);
			sc = s1+s2;
			assert(sc<=M);
			ph = p(sc);
			fprintf(nfg, "%.0f %.0f ", u(s1,ph), u(s2,ph));
		}
	}
}


int	main(int argc, char *argv[])
{
	FILE	*nfg;
	nfg = fopen(argv[1], "wt");
	print_hra(100, 100, atoi(argv[2]), atoi(argv[2]), nfg);
	fclose(nfg);
}


